module Einkaufswagen(
  Einkaufswagen,
  leererWagen,
  einkauf,
  kasse,
  kassenbon
  ) where

import Artikel
import Posten hiding (artikel, menge)
import qualified Posten as P(artikel, menge) 
 
-- Der Einkaufswagen

data Einkaufswagen =
               Einkaufswagen [Posten]
               deriving Show

leererWagen :: Einkaufswagen
leererWagen = Einkaufswagen []

einkauf :: Artikel-> Menge
                  -> Einkaufswagen
                  -> Einkaufswagen
einkauf a m (Einkaufswagen e) =
  case posten a m of
    Just p -> Einkaufswagen (p: e)
    Nothing-> Einkaufswagen e

kasse :: Einkaufswagen-> Int
kasse (Einkaufswagen ps) = sum (map cent ps)

kassenbon :: Einkaufswagen-> String
kassenbon ew@(Einkaufswagen as) = 
  "Bob's Aulde Grocery Shoppe\n\n"++
  "Artikel              Menge      Preis\n"++
  "-------------------------------------\n"++
  concatMap artikel as ++
  "=====================================\n"++
  "Summe:"++ formatR 31 (showEuro (kasse ew))
 
artikel :: Posten-> String
artikel p = 
   formatL 20 (show (P.artikel p)) ++
   formatR 7  (menge (P.menge p)) ++ 
   formatR 10 (showEuro (cent p)) ++ "\n"

menge :: Menge-> String
menge (Stueck n) = show n++ " St" 
menge (Gramm g)  = show g++ " g."
menge (Liter l)  = show l++ " l."

formatL :: Int-> String-> String
formatL n str = take n (str++ replicate n ' ')

formatR :: Int-> String-> String
formatR n str = 
  take n (replicate (n- length str) ' '++ str)

showEuro :: Int-> String
showEuro i = 
  show (div i 100) ++ "."++
  show (mod (div i 10) 10) ++
  show (mod i 10)++ " EU"
