module Lager(
  Lager,
  leeresLager,
  einlagern,
  suche, 
  inventur
  ) where

import Data.Maybe(listToMaybe, fromJust)
import qualified Data.Map.Lazy as M

import Artikel
import Posten

-- Lagerhaltung:
data Lager = Lager (M.Map Artikel Posten)
             deriving Show

leeresLager :: Lager
leeresLager = Lager (M.empty)

einlagern :: Artikel-> Menge-> Lager-> Lager
einlagern a m (Lager l) =
 case posten a m of
   Just p  -> case M.lookup a l of
     Just q  -> Lager (M.insert a (fromJust (hinzu q p)) l)
     Nothing -> Lager (M.insert a p l)
   Nothing -> Lager l

suche :: Artikel-> Lager-> Maybe Menge
suche a (Lager l) =  fmap menge (M.lookup a l)

inventur :: Lager-> Int
inventur (Lager l) = sum (fmap cent l)

