module Posten(
  Posten,
  artikel, 
  menge,
  posten,
  cent,
  hinzu) where

import Data.Maybe(fromJust)

import Artikel

-- Ein Posten ist ein Artikel zu einer bestimmten Menge.
-- Wir exportieren nur den Typ und die Selektoren, nicht den Konstruktor.
data Posten = Posten { artikel :: Artikel
                     , menge   ::  Menge
                     } deriving Show

-- Konstruktor fr Posten 
posten :: Artikel-> Menge-> Maybe Posten 
posten a m = 
  case preis a m of 
    Just _  -> Just (Posten a m)
    Nothing -> Nothing

-- Preis eines Posten
cent :: Posten-> Int
cent (Posten a m) = fromJust (preis a m)
               -- Hier wissen wir, dass der Preis definiert sein muss

hinzu :: Posten-> Posten-> Maybe Posten
hinzu (Posten a1 m1) (Posten a2 m2)
  | a1 == a2  = Just (Posten a1 (addiere m1 m2))
  | otherwise = Nothing 
